<template>
  <div>
    <h2>Dernières tâches en cours</h2>
    <div class="tasks-count">
      {{ dashboardTasksCount }} {{ dashboardTasksCount > 1 ? 'tâches' : 'tâche' }} en cours
    </div>
    <b-overlay
      id="overlay-background"
      :show="loading"
      :variant="'white'"
      :opacity="0.6"
      rounded="sm"
      style="width: 100%; min-height: 340px;"
    >
      <table
        class="data-dashboard table table-based"
        aria-labelledby="Tableau de suivi des tâches en cours"
      >
        <thead>
          <tr>
            <th scope="col">Début</th>
            <th scope="col">Fin</th>
            <th scope="col">Résultat</th>
            <th scope="col" style="text-align: center;">Statut</th>
          </tr>
        </thead>
        <tbody>
          <tr
            v-for="task of dashboardTasksQueue.slice(-10).reverse()"
            :key="task.task_id"
          >
            <td>
              {{
                new Date(task.creation_date).toLocaleString('fr-FR', {
                  year: "2-digit",
                  month: "numeric",
                  day: "numeric",
                  hour: '2-digit',
                  minute: "2-digit",
                  second: "2-digit"
                })
              }}
            </td>
            <td>
              {{
                task.stop_date ? new Date(task.stop_date).toLocaleString('fr-FR', {
                  year: "2-digit",
                  month: "numeric",
                  day: "numeric",
                  hour: '2-digit',
                  minute: "2-digit",
                  second: "2-digit"
                }) : null
              }}
            </td>
            <td>{{  }}</td>
            <td style="
              text-align: right;
              display: flex;
              justify-content: flex-end;
              align-items: center;
            ">
              {{ task.state }}
              <b-icon-check v-if="task.state === 'SUCCESS'" variant="success" font-scale="2" />
              <b-icon-x v-else-if="task.state === 'FAILURE'" variant="danger" font-scale="2" />
              <b-icon-x v-else-if="task.state === 'PENDING'" variant="primary" font-scale="2" />
              <b-icon-dash v-else variant="secondary" font-scale="2" />
            </td>
          </tr>
        </tbody>
      </table>
    </b-overlay>
    <b-button
      v-if="!loading"
      class="btn-lg"
      style="margin-top: 1rem;"
      @click="$router.push({ name: 'Tasks' })"
    >
      Voir toutes les tâches
    </b-button>
  </div>
</template>

<script>
import { mapState, mapActions } from 'vuex';

export default {
  name: 'DatasetDashboard',

  props: {
    data: {
      type: Object,
      default: () => {
        return {}
      }
    }
  },

  data() {
    return {
      loading: false
    }
  },

  computed: {
    ...mapState('dashboard', [
      'dashboardTasksCount',
      'dashboardTasksQueue'
    ])
  },

  created() {
    if (this.dashboardTasksQueue.length === 0) {
      this.loading = true;
      this.GET_DASHBOARD_TASKS()
      .then(() => {
        this.loading = false;
      });
    }
  },

  methods: {
    ...mapActions('dashboard', [
      'GET_DASHBOARD_TASKS'
    ])
  }
}
</script>

<style lang="less" scoped>
.tasks-count {
  position: absolute;
  top: 1rem;
  right: 1rem;
}
</style>
